# ============================
# Set Comma per 3 figures.
# ============================
#---------------------------------------------------------
#G[\
#---------------------------------------------------------

sub setComma #($str)
{
  local($str) = $_[0];

  if ($str =~ /^(-?)([\dA-Fa-f]+)(\..*)?$/) {
    local($mns, $str, $dot) = ($1, $2, $3);
    1 while $str =~ s/([\dA-Fa-f]+)([\dA-Fa-f]{3})/$1,$2/;
    return "$mns$str$dot";
  }
  return $str;
}

sub getSerialTime #($time_zone, $year, $month, $day, $hour, $min, $sec)
{
  local($time_zone, $year, $month, $day, $hour, $min, $sec) = @_;
  local(@day_month, $age, $leap, $time);

  return if ($year eq "");
  @day_month = (0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
  if ($month =~ /^\w{3,9}$/) {
    local(%month) = ('jan'=>1,'feb'=>2,'mar'=>3,'apr'=>4,'may'=>5,'jun'=>6,'jul'=>7,'aug'=>8,'sep'=>9,'oct'=>10,'nov'=>11,'dec'=>12);
    $month = substr $month, 0, 3;
    $month =~ tr/A-Z/a-z/;
    $month = $month{$month};
  }
  $month = 1 if (!$month);
  $day   = 1 if (!$day);
  $age   = $year - 1970;
  $leap  = 1970 <= $year ? &getLeapYearTimes(1970, $year) : &getLeapYearTimes($year, 1970);
  $leap -- if ($year % 4 == 0 && ($year % 400 == 0 || $year % 100 != 0));
  $time  = ($age - $leap) * 31536000;
  $time += $leap * 31622400;
  $time += $day_month[$month-1] * 86400;
  $time += 86400 if ($month >= 3 && $year % 4 == 0 && ($year % 400 == 0 || $year % 100 != 0));
  $time += ($day - 1)  * 86400;
  $time += $hour * 3600;
  $time += $min  * 60;
  $time += $sec;
  return $time - $time_zone;
}

sub getLeapYearTimes #($year1, $year2)
{
  local($year1, $year2) = @_;
  local($year1x, $year2x, $leap);

  return if ($year2 - $year1 < 0);
  while ($year1 % 4 != 0) {
    $year1 ++;
  }
  $year1 += 4 if ($year1 % 100 == 0 && $year1 % 400 != 0);
  while ($year2 % 4 != 0) {
    $year2 --;
  }
  $year2 -= 4 if ($year2 % 100 == 0 && $year2 % 400 != 0);
  $leap = ($year2 - $year1) / 4 + 1;
  $year1x = int($year1 / 100);
  $year2x = int($year2 / 100);
  if ($year2x - $year1x > 0) {
    local($i) = 0;
    for ($year1x .. $year2x) {
      $i ++ if ($_ % 4 == 0);
    }
    $leap -= $year2x - $year1x - $i;
  }
  return $leap;
}
#------------------------------------------------------------------------G[\
sub error {

	open( HTML, './template_error.html' );
	@html = <HTML>;     #DAT$todataɓ
	close(HTML);         #t@C
	foreach $tmp (@html) {
		$tmp =~ s/-%error%-/$error/g;
	}
	close(HTML);         #t@C

	print <<EOM;
Content-type: text/html

 @html
EOM
	exit;
}
sub admin_error {
	open( HTML, './template_admin_error.html' );
	@html = <HTML>;
	close(HTML);
	foreach $tmp (@html) {
		$tmp =~ s/-%error%-/$error/g;
		$tmp =~ s/-%no%-/$in{'no'}/g;
		$tmp =~ s/-%iti%-/$iti/g;
	}
	close(HTML);
	print <<EOM;
Content-type: text/html

 @html
EOM
	exit;
}
1;
